/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1

import (
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
	v1 "k8s.io/test-infra/prow/apis/prowjobs/v1"
)

// ProwJobLister helps list ProwJobs.
type ProwJobLister interface {
	// List lists all ProwJobs in the indexer.
	List(selector labels.Selector) (ret []*v1.ProwJob, err error)
	// ProwJobs returns an object that can list and get ProwJobs.
	ProwJobs(namespace string) ProwJobNamespaceLister
	ProwJobListerExpansion
}

// prowJobLister implements the ProwJobLister interface.
type prowJobLister struct {
	indexer cache.Indexer
}

// NewProwJobLister returns a new ProwJobLister.
func NewProwJobLister(indexer cache.Indexer) ProwJobLister {
	return &prowJobLister{indexer: indexer}
}

// List lists all ProwJobs in the indexer.
func (s *prowJobLister) List(selector labels.Selector) (ret []*v1.ProwJob, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1.ProwJob))
	})
	return ret, err
}

// ProwJobs returns an object that can list and get ProwJobs.
func (s *prowJobLister) ProwJobs(namespace string) ProwJobNamespaceLister {
	return prowJobNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// ProwJobNamespaceLister helps list and get ProwJobs.
type ProwJobNamespaceLister interface {
	// List lists all ProwJobs in the indexer for a given namespace.
	List(selector labels.Selector) (ret []*v1.ProwJob, err error)
	// Get retrieves the ProwJob from the indexer for a given namespace and name.
	Get(name string) (*v1.ProwJob, error)
	ProwJobNamespaceListerExpansion
}

// prowJobNamespaceLister implements the ProwJobNamespaceLister
// interface.
type prowJobNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all ProwJobs in the indexer for a given namespace.
func (s prowJobNamespaceLister) List(selector labels.Selector) (ret []*v1.ProwJob, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1.ProwJob))
	})
	return ret, err
}

// Get retrieves the ProwJob from the indexer for a given namespace and name.
func (s prowJobNamespaceLister) Get(name string) (*v1.ProwJob, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1.Resource("prowjob"), name)
	}
	return obj.(*v1.ProwJob), nil
}
