#!/usr/bin/env bash
# Copyright 2019 The Kubernetes Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set -o errexit
set -o nounset
set -o pipefail

proj=k8s-prow-builds
pool=prow-pool
workers=200
disk=600
machine=n1-standard-2
bot=pr-kubekins@kubernetes-jenkins-pull.iam.gserviceaccount.com

"$(dirname "$0")/install.sh" "$proj" "$pool" "$workers" "$disk" "$machine" "$bot"
