/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by protoc-gen-go. DO NOT EDIT.
// source: issue_state.proto

package issue_state

import (
	fmt "fmt"
	proto "github.com/golang/protobuf/proto"
	math "math"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion3 // please upgrade the proto package

type IssueInfo struct {
	IssueId              string   `protobuf:"bytes,1,opt,name=issue_id,json=issueId,proto3" json:"issue_id,omitempty"`
	Title                string   `protobuf:"bytes,2,opt,name=title,proto3" json:"title,omitempty"`
	RowIds               []string `protobuf:"bytes,5,rep,name=row_ids,json=rowIds,proto3" json:"row_ids,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *IssueInfo) Reset()         { *m = IssueInfo{} }
func (m *IssueInfo) String() string { return proto.CompactTextString(m) }
func (*IssueInfo) ProtoMessage()    {}
func (*IssueInfo) Descriptor() ([]byte, []int) {
	return fileDescriptor_0231a95aac646693, []int{0}
}

func (m *IssueInfo) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_IssueInfo.Unmarshal(m, b)
}
func (m *IssueInfo) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_IssueInfo.Marshal(b, m, deterministic)
}
func (m *IssueInfo) XXX_Merge(src proto.Message) {
	xxx_messageInfo_IssueInfo.Merge(m, src)
}
func (m *IssueInfo) XXX_Size() int {
	return xxx_messageInfo_IssueInfo.Size(m)
}
func (m *IssueInfo) XXX_DiscardUnknown() {
	xxx_messageInfo_IssueInfo.DiscardUnknown(m)
}

var xxx_messageInfo_IssueInfo proto.InternalMessageInfo

func (m *IssueInfo) GetIssueId() string {
	if m != nil {
		return m.IssueId
	}
	return ""
}

func (m *IssueInfo) GetTitle() string {
	if m != nil {
		return m.Title
	}
	return ""
}

func (m *IssueInfo) GetRowIds() []string {
	if m != nil {
		return m.RowIds
	}
	return nil
}

type IssueState struct {
	// List of collected info for bugs.
	IssueInfo            []*IssueInfo `protobuf:"bytes,1,rep,name=issue_info,json=issueInfo,proto3" json:"issue_info,omitempty"`
	XXX_NoUnkeyedLiteral struct{}     `json:"-"`
	XXX_unrecognized     []byte       `json:"-"`
	XXX_sizecache        int32        `json:"-"`
}

func (m *IssueState) Reset()         { *m = IssueState{} }
func (m *IssueState) String() string { return proto.CompactTextString(m) }
func (*IssueState) ProtoMessage()    {}
func (*IssueState) Descriptor() ([]byte, []int) {
	return fileDescriptor_0231a95aac646693, []int{1}
}

func (m *IssueState) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_IssueState.Unmarshal(m, b)
}
func (m *IssueState) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_IssueState.Marshal(b, m, deterministic)
}
func (m *IssueState) XXX_Merge(src proto.Message) {
	xxx_messageInfo_IssueState.Merge(m, src)
}
func (m *IssueState) XXX_Size() int {
	return xxx_messageInfo_IssueState.Size(m)
}
func (m *IssueState) XXX_DiscardUnknown() {
	xxx_messageInfo_IssueState.DiscardUnknown(m)
}

var xxx_messageInfo_IssueState proto.InternalMessageInfo

func (m *IssueState) GetIssueInfo() []*IssueInfo {
	if m != nil {
		return m.IssueInfo
	}
	return nil
}

func init() {
	proto.RegisterType((*IssueInfo)(nil), "IssueInfo")
	proto.RegisterType((*IssueState)(nil), "IssueState")
}

func init() { proto.RegisterFile("issue_state.proto", fileDescriptor_0231a95aac646693) }

var fileDescriptor_0231a95aac646693 = []byte{
	// 176 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x3c, 0x8e, 0xb1, 0xca, 0xc2, 0x30,
	0x14, 0x46, 0xe9, 0xdf, 0xb4, 0x49, 0xee, 0xbf, 0xc4, 0x20, 0x18, 0xb7, 0xd2, 0xa9, 0x2e, 0x1d,
	0x74, 0xf0, 0x19, 0x92, 0xb1, 0x3e, 0x40, 0x51, 0xd2, 0x42, 0x40, 0x7b, 0x25, 0x89, 0xf4, 0xf5,
	0xa5, 0xa9, 0xba, 0xdd, 0xef, 0x70, 0xe1, 0x1c, 0xd8, 0xb8, 0x10, 0x5e, 0x43, 0x1f, 0xe2, 0x35,
	0x0e, 0xed, 0xd3, 0x63, 0xc4, 0xfa, 0x01, 0x5c, 0x2f, 0x50, 0x4f, 0x23, 0xca, 0x3d, 0xb0, 0xf5,
	0xc3, 0x59, 0x95, 0x55, 0x59, 0xc3, 0x3b, 0x9a, 0xb6, 0xb6, 0x72, 0x0b, 0x45, 0x74, 0xf1, 0x3e,
	0xa8, 0xbf, 0xc4, 0xd7, 0x21, 0x77, 0x40, 0x3d, 0xce, 0xbd, 0xb3, 0x41, 0x15, 0x55, 0xde, 0xf0,
	0xae, 0xf4, 0x38, 0x6b, 0x1b, 0x0c, 0x61, 0xb9, 0x20, 0x86, 0x30, 0x22, 0x0a, 0x43, 0x58, 0x29,
	0xa8, 0x21, 0x8c, 0x0a, 0x56, 0x9f, 0x01, 0x92, 0xee, 0xb2, 0x24, 0xc8, 0x03, 0xc0, 0xc7, 0x37,
	0x8d, 0xa8, 0xb2, 0x2a, 0x6f, 0xfe, 0x8f, 0xd0, 0xfe, 0x7a, 0x3a, 0xee, 0xbe, 0xe7, 0xad, 0x4c,
	0xb9, 0xa7, 0x77, 0x00, 0x00, 0x00, 0xff, 0xff, 0xf4, 0xf3, 0x59, 0x3f, 0xc3, 0x00, 0x00, 0x00,
}
